osgParticle::ParticleProcessor Class Referenceabstract

`#include <ParticleProcessor>`

Inheritance diagram for osgParticle::ParticleProcessor:

## Public Types

enum | ReferenceFrame { RELATIVE_RF , ABSOLUTE_RF }
Public Types inherited from osg::Node
typedef std::vector< Group * > | ParentList
typedef unsigned int | NodeMask
typedef std::vector< std::string > | DescriptionList
Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }

## Public Member Functions

| ParticleProcessor ()
| ParticleProcessor (const ParticleProcessor &copy, const osg::CopyOp &copyop=osg::CopyOp::SHALLOW_COPY)
virtual const char * | libraryName () const
virtual const char * | className () const
virtual bool | isSameKindAs (const osg::Object *obj) const
virtual void | accept (osg::NodeVisitor &nv)
ReferenceFrame | getReferenceFrame () const
| Get the reference frame.
void | setReferenceFrame (ReferenceFrame rf)
| Set the reference frame.
bool | getEnabled () const
| Get whether this processor is enabled or not.
bool | isEnabled () const
void | setEnabled (bool v)
| Set whether this processor is enabled or not.
ParticleSystem * | getParticleSystem ()
| Get a pointer to the destination particle system.
const ParticleSystem * | getParticleSystem () const
| Get a const pointer to the destination particle system.
virtual void | setParticleSystem (ParticleSystem *ps)
| Set the destination particle system.
void | setEndless (bool type)
| Set the endless flag of this processor.
bool | getEndless () const
| Check whether this processor is endless.
bool | isEndless () const
void | setLifeTime (double t)
| Set the lifetime of this processor.
double | getLifeTime () const
| Get the lifetime of this processor.
void | setStartTime (double t)
| Set the start time of this processor.
double | getStartTime () const
| Get the start time of this processor.
void | setCurrentTime (double t)
| Set the current time of this processor.
double | getCurrentTime () const
| Get the current time of this processor.
void | setResetTime (double t)
| Set the reset time of this processor. A value of 0 disables reset.
double | getResetTime () const
| Get the reset time of this processor.
bool | isAlive () const
void | traverse (osg::NodeVisitor &nv)
const osg::Matrix & | getLocalToWorldMatrix ()
| Get the current local-to-world transformation matrix (valid only during cull traversal).
const osg::Matrix & | getWorldToLocalMatrix ()
| Get the current world-to-local transformation matrix (valid only during cull traversal).
const osg::Matrix & | getPreviousLocalToWorldMatrix ()
| Get the previous local-to-world transformation matrix (valid only during cull traversal).
const osg::Matrix & | getPreviousWorldToLocalMatrix ()
| Get the previous world-to-local transformation matrix (valid only during cull traversal).
osg::Vec3 | transformLocalToWorld (const osg::Vec3 &P)
| Transform a point from local to world coordinates (valid only during cull traversal).
osg::Vec3 | rotateLocalToWorld (const osg::Vec3 &P)
| Transform a vector from local to world coordinates, discarding translation (valid only during cull traversal).
osg::Vec3 | transformWorldToLocal (const osg::Vec3 &P)
| Transform a point from world to local coordinates (valid only during cull traversal).
osg::Vec3 | rotateWorldToLocal (const osg::Vec3 &P)
| Transform a vector from world to local coordinates, discarding translation (valid only during cull traversal).
virtual osg::BoundingSphere | computeBound () const
Public Member Functions inherited from osg::Node
| Node ()
| Node (const Node &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const
virtual Object * | clone (const CopyOp &copyop) const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual Geometry * | asGeometry ()
virtual const Geometry * | asGeometry () const
virtual Group * | asGroup ()
virtual const Group * | asGroup () const
virtual Transform * | asTransform ()
virtual const Transform * | asTransform () const
virtual Switch * | asSwitch ()
virtual const Switch * | asSwitch () const
virtual Geode * | asGeode ()
virtual const Geode * | asGeode () const
virtual osgTerrain::Terrain * | asTerrain ()
virtual const osgTerrain::Terrain * | asTerrain () const
virtual void | ascend (NodeVisitor &nv)
const ParentList & | getParents () const
ParentList | getParents ()
Group * | getParent (unsigned int i)
const Group * | getParent (unsigned int i) const
unsigned int | getNumParents () const
NodePathList | getParentalNodePaths (osg::Node *haltTraversalAtNode=0) const
MatrixList | getWorldMatrices (const osg::Node *haltTraversalAtNode=0) const
void | setUpdateCallback (Callback *nc)
template<class T>
void | setUpdateCallback (const ref_ptr< T > &nc)
Callback * | getUpdateCallback ()
const Callback * | getUpdateCallback () const
void | addUpdateCallback (Callback *nc)
template<class T>
void | addUpdateCallback (const ref_ptr< T > &nc)
void | removeUpdateCallback (Callback *nc)
template<class T>
void | removeUpdateCallback (const ref_ptr< T > &nc)
unsigned int | getNumChildrenRequiringUpdateTraversal () const
void | setEventCallback (Callback *nc)
template<class T>
void | setEventCallback (const ref_ptr< T > &nc)
Callback * | getEventCallback ()
const Callback * | getEventCallback () const
void | addEventCallback (Callback *nc)
template<class T>
void | addEventCallback (const ref_ptr< T > &nc)
void | removeEventCallback (Callback *nc)
template<class T>
void | removeEventCallback (const ref_ptr< T > &nc)
unsigned int | getNumChildrenRequiringEventTraversal () const
void | setCullCallback (Callback *nc)
template<class T>
void | setCullCallback (const ref_ptr< T > &nc)
Callback * | getCullCallback ()
const Callback * | getCullCallback () const
void | addCullCallback (Callback *nc)
template<class T>
void | addCullCallback (const ref_ptr< T > &nc)
void | removeCullCallback (Callback *nc)
template<class T>
void | removeCullCallback (const ref_ptr< T > &nc)
void | setCullingActive (bool active)
bool | getCullingActive () const
unsigned int | getNumChildrenWithCullingDisabled () const
bool | isCullingActive () const
unsigned int | getNumChildrenWithOccluderNodes () const
bool | containsOccluderNodes () const
void | setNodeMask (NodeMask nm)
NodeMask | getNodeMask () const
void | setStateSet (osg::StateSet *stateset)
template<class T>
void | setStateSet (const osg::ref_ptr< T > &stateset)
osg::StateSet * | getOrCreateStateSet ()
osg::StateSet * | getStateSet ()
const osg::StateSet * | getStateSet () const
void | setDescriptions (const DescriptionList &descriptions)
DescriptionList & | getDescriptions ()
const DescriptionList & | getDescriptions () const
const std::string & | getDescription (unsigned int i) const
std::string & | getDescription (unsigned int i)
unsigned int | getNumDescriptions () const
void | addDescription (const std::string &desc)
void | setInitialBound (const osg::BoundingSphere &bsphere)
const BoundingSphere & | getInitialBound () const
void | dirtyBound ()
const BoundingSphere & | getBound () const
void | setComputeBoundingSphereCallback (ComputeBoundingSphereCallback *callback)
template<class T>
void | setComputeBoundingSphereCallback (const ref_ptr< T > &callback)
ComputeBoundingSphereCallback * | getComputeBoundingSphereCallback ()
const ComputeBoundingSphereCallback * | getComputeBoundingSphereCallback () const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | resizeGLObjectBuffers (unsigned int)
virtual void | releaseGLObjects (osg::State *=0) const
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
std::string | getCompoundClassName () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Protected Member Functions

virtual | ~ParticleProcessor ()
ParticleProcessor & | operator= (const ParticleProcessor &)
virtual void | process (double dt)=0
Protected Member Functions inherited from osg::Node
virtual | ~Node ()
void | addParent (osg::Group *parent)
void | removeParent (osg::Group *parent)
void | setNumChildrenRequiringUpdateTraversal (unsigned int num)
void | setNumChildrenRequiringEventTraversal (unsigned int num)
void | setNumChildrenWithCullingDisabled (unsigned int num)
void | setNumChildrenWithOccluderNodes (unsigned int num)
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Protected Attributes

ReferenceFrame | _rf
bool | _enabled
double | _t0
osg::ref_ptr< ParticleSystem > | _ps
bool | _first_ltw_compute
bool | _need_ltw_matrix
bool | _first_wtl_compute
bool | _need_wtl_matrix
osg::Matrix | _ltw_matrix
osg::Matrix | _wtl_matrix
osg::Matrix | _previous_ltw_matrix
osg::Matrix | _previous_wtl_matrix
osg::NodeVisitor * | _current_nodevisitor
bool | _endless
double | _lifeTime
double | _startTime
double | _currentTime
double | _resetTime
unsigned int | _frameNumber
Protected Attributes inherited from osg::Node
BoundingSphere | _initialBound
ref_ptr< ComputeBoundingSphereCallback > | _computeBoundCallback
BoundingSphere | _boundingSphere
bool | _boundingSphereComputed
ParentList | _parents
ref_ptr< Callback > | _updateCallback
unsigned int | _numChildrenRequiringUpdateTraversal
ref_ptr< Callback > | _eventCallback
unsigned int | _numChildrenRequiringEventTraversal
ref_ptr< Callback > | _cullCallback
bool | _cullingActive
unsigned int | _numChildrenWithCullingDisabled
unsigned int | _numChildrenWithOccluderNodes
NodeMask | _nodeMask
ref_ptr< StateSet > | _stateset
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Additional Inherited Members

Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()

## Detailed Description

A common base interface for those classes which need to do something on particles. Such classes are, for example, Emitter (particle generation) and Program (particle animation). This class holds some properties, like a reference frame and a reference to a ParticleSystem; descendant classes should process the particles taking into account the reference frame, computing the right transformations when needed.

## Member Enumeration Documentation

## ReferenceFrame

enum osgParticle::ParticleProcessor::ReferenceFrame

Enumerator
RELATIVE_RF |
ABSOLUTE_RF |

## Constructor & Destructor Documentation

## ParticleProcessor() [1/2]

osgParticle::ParticleProcessor::ParticleProcessor | ( |  | ) |

Referenced by isSameKindAs(), operator=(), and ParticleProcessor().

## ParticleProcessor() [2/2]

osgParticle::ParticleProcessor::ParticleProcessor | ( | const ParticleProcessor & | copy,
|  | const osg::CopyOp & | copyop = osg::CopyOp::SHALLOW_COPY )

References ParticleProcessor(), and osg::CopyOp::SHALLOW_COPY.

## ~ParticleProcessor()

virtual osgParticle::ParticleProcessor::~ParticleProcessor | ( |  | ) |

inline protected virtual

## Member Function Documentation

## accept()

virtual void osgParticle::ParticleProcessor::accept | ( | osg::NodeVisitor & | nv | ) |

inline virtual

Visitor Pattern : calls the apply method of a NodeVisitor with this node's type.

Reimplemented from osg::Node.

Reimplemented in osgParticle::Emitter, and osgParticle::Program.

References osg::NodeVisitor::apply(), osg::NodeVisitor::popFromNodePath(), osg::NodeVisitor::pushOntoNodePath(), and osg::NodeVisitor::validNodeMask().

## className()

virtual const char * osgParticle::ParticleProcessor::className | ( |  | ) | const

inline virtual

return the name of the node's class type.

Reimplemented from osg::Node.

Reimplemented in osgParticle::Emitter, and osgParticle::Program.

## computeBound()

virtual osg::BoundingSphere osgParticle::ParticleProcessor::computeBound | ( |  | ) | const

virtual

Compute the bounding sphere around Node's geometry or children. This method is automatically called by getBound() when the bounding sphere has been marked dirty via dirtyBound().

Reimplemented from osg::Node.

## getCurrentTime()

double osgParticle::ParticleProcessor::getCurrentTime | ( |  | ) | const

inline

Get the current time of this processor.

References _currentTime.

## getEnabled()

bool osgParticle::ParticleProcessor::getEnabled | ( |  | ) | const

inline

Get whether this processor is enabled or not.

References _enabled.

## getEndless()

bool osgParticle::ParticleProcessor::getEndless | ( |  | ) | const

inline

Check whether this processor is endless.

References _endless.

## getLifeTime()

double osgParticle::ParticleProcessor::getLifeTime | ( |  | ) | const

inline

Get the lifetime of this processor.

References _lifeTime.

## getLocalToWorldMatrix()

const osg::Matrix & osgParticle::ParticleProcessor::getLocalToWorldMatrix | ( |  | ) |

inline

Get the current local-to-world transformation matrix (valid only during cull traversal).

References _current_nodevisitor, _first_ltw_compute, _ltw_matrix, _need_ltw_matrix, _previous_ltw_matrix, and osg::computeLocalToWorld().

Referenced by getPreviousLocalToWorldMatrix(), rotateLocalToWorld(), transformLocalToWorld(), and traverse().

## getParticleSystem() [1/2]

ParticleSystem * osgParticle::ParticleProcessor::getParticleSystem | ( |  | ) |

inline

Get a pointer to the destination particle system.

References _ps.

## getParticleSystem() [2/2]

const ParticleSystem * osgParticle::ParticleProcessor::getParticleSystem | ( |  | ) | const

inline

Get a const pointer to the destination particle system.

References _ps.

## getPreviousLocalToWorldMatrix()

const osg::Matrix & osgParticle::ParticleProcessor::getPreviousLocalToWorldMatrix | ( |  | ) |

inline

Get the previous local-to-world transformation matrix (valid only during cull traversal).

References _need_ltw_matrix, _previous_ltw_matrix, and getLocalToWorldMatrix().

Referenced by traverse().

## getPreviousWorldToLocalMatrix()

const osg::Matrix & osgParticle::ParticleProcessor::getPreviousWorldToLocalMatrix | ( |  | ) |

inline

Get the previous world-to-local transformation matrix (valid only during cull traversal).

References _need_wtl_matrix, _previous_wtl_matrix, and getWorldToLocalMatrix().

Referenced by traverse().

## getReferenceFrame()

ParticleProcessor::ReferenceFrame osgParticle::ParticleProcessor::getReferenceFrame | ( |  | ) | const

inline

Get the reference frame.

References _rf.

Referenced by osgParticle::AccelOperator::beginOperate(), osgParticle::AngularAccelOperator::beginOperate(), osgParticle::ExplosionOperator::beginOperate(), osgParticle::ForceOperator::beginOperate(), and osgParticle::OrbitOperator::beginOperate().

## getResetTime()

double osgParticle::ParticleProcessor::getResetTime | ( |  | ) | const

inline

Get the reset time of this processor.

References _resetTime.

## getStartTime()

double osgParticle::ParticleProcessor::getStartTime | ( |  | ) | const

inline

Get the start time of this processor.

References _startTime.

## getWorldToLocalMatrix()

const osg::Matrix & osgParticle::ParticleProcessor::getWorldToLocalMatrix | ( |  | ) |

inline

Get the current world-to-local transformation matrix (valid only during cull traversal).

References _current_nodevisitor, _first_wtl_compute, _need_wtl_matrix, _previous_wtl_matrix, _wtl_matrix, and osg::computeWorldToLocal().

Referenced by getPreviousWorldToLocalMatrix(), rotateWorldToLocal(), transformWorldToLocal(), and traverse().

## isAlive()

bool osgParticle::ParticleProcessor::isAlive | ( |  | ) | const

inline

Check whether the processor is alive with respect to start time and life duration. Note that this method may return true even if the processor has been disabled by calling setEnabled(false). To test whether the processor is actually processing particles or not, you should evaluate (isEnabled() && isAlive()).

References _currentTime, _lifeTime, and _startTime.

## isEnabled()

bool osgParticle::ParticleProcessor::isEnabled | ( |  | ) | const

inline

References _enabled.

## isEndless()

bool osgParticle::ParticleProcessor::isEndless | ( |  | ) | const

inline

References _endless.

## isSameKindAs()

virtual bool osgParticle::ParticleProcessor::isSameKindAs | ( | const osg::Object * | obj | ) | const

inline virtual

return true if this and obj are of the same kind of object.

Reimplemented from osg::Node.

Reimplemented in osgParticle::Emitter, and osgParticle::Program.

References ParticleProcessor().

## libraryName()

virtual const char * osgParticle::ParticleProcessor::libraryName | ( |  | ) | const

inline virtual

return the name of the node's library.

Reimplemented from osg::Node.

Reimplemented in osgParticle::Emitter, and osgParticle::Program.

## operator=()

ParticleProcessor & osgParticle::ParticleProcessor::operator= | ( | const ParticleProcessor & |  | ) |

inline protected

References ParticleProcessor().

## process()

virtual void osgParticle::ParticleProcessor::process | ( | double | dt | ) |

protected pure virtual

Implemented in osgParticle::Emitter, and osgParticle::Program.

## rotateLocalToWorld()

osg::Vec3 osgParticle::ParticleProcessor::rotateLocalToWorld | ( | const osg::Vec3 & | P | ) |

inline

Transform a vector from local to world coordinates, discarding translation (valid only during cull traversal).

References getLocalToWorldMatrix(), and osg::Matrixd::preMult().

Referenced by osgParticle::AccelOperator::beginOperate(), osgParticle::AngularAccelOperator::beginOperate(), osgParticle::ForceOperator::beginOperate(), and traverse().

## rotateWorldToLocal()

osg::Vec3 osgParticle::ParticleProcessor::rotateWorldToLocal | ( | const osg::Vec3 & | P | ) |

inline

Transform a vector from world to local coordinates, discarding translation (valid only during cull traversal).

References getWorldToLocalMatrix(), and osg::Matrixd::preMult().

Referenced by traverse().

## setCurrentTime()

void osgParticle::ParticleProcessor::setCurrentTime | ( | double | t | ) |

inline

Set the current time of this processor.

References _currentTime.

## setEnabled()

void osgParticle::ParticleProcessor::setEnabled | ( | bool | v | ) |

inline

Set whether this processor is enabled or not.

References _currentTime, and _enabled.

## setEndless()

void osgParticle::ParticleProcessor::setEndless | ( | bool | type | ) |

inline

Set the endless flag of this processor.

References _endless.

Referenced by setParticleSystem().

## setLifeTime()

void osgParticle::ParticleProcessor::setLifeTime | ( | double | t | ) |

inline

Set the lifetime of this processor.

References _lifeTime.

## setParticleSystem()

virtual void osgParticle::ParticleProcessor::setParticleSystem | ( | ParticleSystem * | ps | ) |

virtual

Set the destination particle system.

Reimplemented in osgParticle::Emitter.

References setEndless().

## setReferenceFrame()

void osgParticle::ParticleProcessor::setReferenceFrame | ( | ReferenceFrame | rf | ) |

inline

Set the reference frame.

References _rf.

## setResetTime()

void osgParticle::ParticleProcessor::setResetTime | ( | double | t | ) |

inline

Set the reset time of this processor. A value of 0 disables reset.

References _resetTime.

## setStartTime()

void osgParticle::ParticleProcessor::setStartTime | ( | double | t | ) |

inline

Set the start time of this processor.

References _startTime.

## transformLocalToWorld()

osg::Vec3 osgParticle::ParticleProcessor::transformLocalToWorld | ( | const osg::Vec3 & | P | ) |

inline

Transform a point from local to world coordinates (valid only during cull traversal).

References getLocalToWorldMatrix(), and osg::Matrixd::preMult().

Referenced by osgParticle::ExplosionOperator::beginOperate(), osgParticle::OrbitOperator::beginOperate(), and traverse().

## transformWorldToLocal()

osg::Vec3 osgParticle::ParticleProcessor::transformWorldToLocal | ( | const osg::Vec3 & | P | ) |

inline

Transform a point from world to local coordinates (valid only during cull traversal).

References getWorldToLocalMatrix(), and osg::Matrixd::preMult().

Referenced by traverse().

## traverse()

void osgParticle::ParticleProcessor::traverse | ( | osg::NodeVisitor & |  | ) |

virtual

Traverse downwards : calls children's accept method with NodeVisitor.

Reimplemented from osg::Node.

References getLocalToWorldMatrix(), getPreviousLocalToWorldMatrix(), getPreviousWorldToLocalMatrix(), getWorldToLocalMatrix(), rotateLocalToWorld(), rotateWorldToLocal(), transformLocalToWorld(), and transformWorldToLocal().

## Member Data Documentation

## _current_nodevisitor

osg::NodeVisitor* osgParticle::ParticleProcessor::_current_nodevisitor

protected

Referenced by getLocalToWorldMatrix(), and getWorldToLocalMatrix().

## _currentTime

double osgParticle::ParticleProcessor::_currentTime

protected

Referenced by getCurrentTime(), isAlive(), setCurrentTime(), and setEnabled().

## _enabled

bool osgParticle::ParticleProcessor::_enabled

protected

Referenced by getEnabled(), isEnabled(), and setEnabled().

## _endless

bool osgParticle::ParticleProcessor::_endless

protected

Referenced by getEndless(), isEndless(), and setEndless().

## _first_ltw_compute

bool osgParticle::ParticleProcessor::_first_ltw_compute

protected

Referenced by getLocalToWorldMatrix().

## _first_wtl_compute

bool osgParticle::ParticleProcessor::_first_wtl_compute

protected

Referenced by getWorldToLocalMatrix().

## _frameNumber

unsigned int osgParticle::ParticleProcessor::_frameNumber

protected

## _lifeTime

double osgParticle::ParticleProcessor::_lifeTime

protected

Referenced by getLifeTime(), isAlive(), and setLifeTime().

## _ltw_matrix

osg::Matrix osgParticle::ParticleProcessor::_ltw_matrix

protected

Referenced by getLocalToWorldMatrix().

## _need_ltw_matrix

bool osgParticle::ParticleProcessor::_need_ltw_matrix

protected

Referenced by getLocalToWorldMatrix(), and getPreviousLocalToWorldMatrix().

## _need_wtl_matrix

bool osgParticle::ParticleProcessor::_need_wtl_matrix

protected

Referenced by getPreviousWorldToLocalMatrix(), and getWorldToLocalMatrix().

## _previous_ltw_matrix

osg::Matrix osgParticle::ParticleProcessor::_previous_ltw_matrix

protected

Referenced by getLocalToWorldMatrix(), and getPreviousLocalToWorldMatrix().

## _previous_wtl_matrix

osg::Matrix osgParticle::ParticleProcessor::_previous_wtl_matrix

protected

Referenced by getPreviousWorldToLocalMatrix(), and getWorldToLocalMatrix().

## _ps

osg::ref_ptr<ParticleSystem> osgParticle::ParticleProcessor::_ps

protected

Referenced by getParticleSystem(), and getParticleSystem().

## _resetTime

double osgParticle::ParticleProcessor::_resetTime

protected

Referenced by getResetTime(), and setResetTime().

## _rf

ReferenceFrame osgParticle::ParticleProcessor::_rf

protected

Referenced by getReferenceFrame(), and setReferenceFrame().

## _startTime

double osgParticle::ParticleProcessor::_startTime

protected

Referenced by getStartTime(), isAlive(), and setStartTime().

## _t0

double osgParticle::ParticleProcessor::_t0

protected

## _wtl_matrix

osg::Matrix osgParticle::ParticleProcessor::_wtl_matrix

protected

Referenced by getWorldToLocalMatrix().

The documentation for this class was generated from the following file:

- ParticleProcessor